﻿---- menu region ----
--- slash commands here ---
local addonName, addonTable = ...
local C = addonTable.C
local L = addonTable.L

local mn_main = 0
local mn_multi1 = 1
local mn_multi2a = 2
local mn_credits = 3
local mn_results = 4
local mn_options = 5
local mn_connlost = 6
local mn_gamereq = 7
local mn_help = 8
local waiting_response = false
local menustate = mn_main

local btn_spacing = 0

local p1_name,p1_score,p1_wf,
      p2_name,p2_score,p2_wf = "","",{},"","",{}

local function GenerateMenuButtons()
 if not Wowzzle_Menuframe then return end

 Wowzzle_Menuframe:SetWidth(200)
 Wowzzle_Menuframe:SetHeight(300)

 local f = Wowzzle_Menuframe.buttons
 table.foreach(f, function(_,v)
  v:Enable()
  v:Hide()
  v:ClearAllPoints()
  v:SetScript("OnClick", nil)
  v:SetScript("OnEnter", nil)
  v:SetScript("OnLeave", nil)
  v:SetScript("OnUpdate", nil)
 end)
 
 local edt = Wowzzle__editbox
 if edt then
  edt:Enable()
  edt:Hide()
  edt:ClearAllPoints()
 end 
 waiting_response = false

 if menustate == mn_credits then
   ----------------- credits ------------------
  f[1]:SetText(addonName)
  f[1]:SetPoint("TOP", Wowzzle_Menuframe.tex, "BOTTOM", 0, btn_spacing)
  f[1]:Disable()
  f[1]:SetScript("OnUpdate", function()
   f[1]:SetPoint("TOP", Wowzzle_Menuframe.tex, "BOTTOM", min(120,max(-20,math.sin(GetTime())*100+80)), -10) 
  end)
  f[1]:Show()
  
  f[2]:SetText("by")
  f[2]:SetPoint("TOP", Wowzzle_Menuframe.tex, "BOTTOM", 0, btn_spacing)
  f[2]:Disable()
  f[2]:SetScript("OnUpdate", function()
   f[2]:SetPoint("TOP", Wowzzle_Menuframe.tex, "BOTTOM", min(140,max(-20,math.cos(GetTime())*100+50)), -30) 
  end)
  f[2]:Show()
  
  f[3]:SetText("Fluffies - EU Well of Eternity")
  f[3]:SetPoint("TOP", Wowzzle_Menuframe.tex, "BOTTOM", 0, btn_spacing)
  f[3]:Disable()
  f[3]:SetScript("OnUpdate", function()
   f[3]:SetPoint("TOP", Wowzzle_Menuframe.tex, "BOTTOM", min(0,max(-20,math.sin(GetTime())*70)), -50)
  end)
  f[3]:Show()
  
  f[4]:SetText(L["backtomenu"])
  f[4]:SetPoint("BOTTOM", Wowzzle_Menuframe, "BOTTOM", 0, 20)
  f[4]:SetScript("OnClick", function()
   menustate = mn_main
   GenerateMenuButtons()
  end)
  f[4]:Show()
 elseif menustate == mn_multi1 then
  -- multiplayer menu page 1 ( challenge a player, scanner, back to main menu )
  f[1]:SetText(L["challenge"])
  f[1]:SetPoint("TOP", Wowzzle_Menuframe.tex, "BOTTOM", 0, btn_spacing) 
  f[1]:SetScript("OnClick", function()
      menustate = mn_multi2a
      GenerateMenuButtons()
  end)
  f[1]:Show()
  
  
  f[2]:SetText(L["scanguild"])
  f[2]:SetPoint("TOP", f[1], "BOTTOM", 0, btn_spacing) 
  f[2]:SetScript("OnClick", function()
       addonTable.ScanForWowzzlePlayers(ddscanselection)
       f[3]:SetText(L["scanning"])
       f[3]:SetScript("OnEnter", nil)
       f[3]:SetScript("OnLeave", nil)
       addonTable.tmp_scanfunc = 
        function(s)
         waiting_response = false
         f[3]:Enable()
         if s and s ~= "" then
          f[3]:SetText(L["gmfound"])
          f[3]:SetScript("OnEnter", function()
           GameTooltip:SetOwner(f[3],"ANCHOR_NONE")
           GameTooltip:ClearAllPoints()
           GameTooltip:SetPoint("LEFT", f[3], "RIGHT")
           GameTooltip:ClearLines()
           GameTooltip:AddLine("|cff00ff00"..s.."|r")
           GameTooltip:Show()
          end)
          f[3]:SetScript("OnLeave", function()
           GameTooltip:Hide()
          end)
         else
          f[3]:SetText(L["nogm"])
          f[3]:Disable()
         end
        end
       waiting_response = true
       addonTable.Timer_Start(4, 2, addonTable.tmp_scanfunc)
      end)
  f[2]:Show()

  f[3]:SetText(L["readytoscan"])
  f[3]:Disable()
  f[3]:SetPoint("TOP", f[2], "BOTTOM", 0, btn_spacing)
  f[3]:Show()

  f[4]:SetText(L["backtomenu"])
  f[4]:SetPoint("TOP", f[3], "BOTTOM", 0, btn_spacing)
  f[4]:SetScript("OnClick", function()
   menustate = mn_main
   addonTable.tmp_scanfunc = nil
   GenerateMenuButtons()
  end)
  f[4]:Show()
 elseif menustate == mn_multi2a then
  -- multiplayer menu page 2a ( player name editbox, send invite, back to multi1 )
   local function send_invite()
    edt:ClearFocus()
    local s = edt:GetText()
    if s and s ~= "" and s ~= UnitName("player") then
     SendAddonMessage(C["prefix"], C["gamereq"]..addonTable.version, "WHISPER", s)
     print(L["addontag"]..L["isent"])
    end
   end
   
  f[1]:SetText(L["inspname"])
  f[1]:SetPoint("TOP", Wowzzle_Menuframe.tex, "BOTTOM", 0, btn_spacing) 
  f[1]:Disable()
  f[1]:Show()

  edt:SetScript("OnEnterPressed",  send_invite)
  edt:SetPoint("TOP", f[1], "BOTTOM", 0, 0)
  edt:Show()
  
  f[2]:SetText(L["sendinvite"])
  f[2]:SetPoint("TOP", edt, "BOTTOM", 0, btn_spacing) 
  f[2]:SetScript("OnClick", send_invite)
  f[2]:Show()

  f[3]:SetText(L["back"])
  f[3]:SetPoint("TOP", f[2], "BOTTOM", 0, btn_spacing)
  f[3]:SetScript("OnClick", function()
   menustate = mn_multi1
   GenerateMenuButtons()
  end)
  f[3]:Show()
 elseif menustate == mn_results then
  -- end game results ( player names, scores and words found )
  
  f[1]:SetText("|cff00aaff"..p1_name.."|r")
  f[1]:SetPoint("TOP", Wowzzle_Menuframe.tex, "BOTTOM", 0, btn_spacing) 
  f[1]:Disable()
  f[1]:Show()

  f[2]:SetText(L["score"].."|cff00ff00"..p1_score)
  f[2]:SetPoint("TOP", f[1], "BOTTOM", 0, 0) 
  f[2]:Disable()
  f[2]:Show()
  
  if p2_name ~= "" then
   Wowzzle_Menuframe:SetHeight(380)
   
   f[3]:SetText("|cff00aaff"..p2_name.."|r")
   f[3]:SetPoint("TOP", f[2], "BOTTOM", 0, btn_spacing * 3) 
   f[3]:Disable()
   f[3]:Show()

   f[4]:SetText(L["score"].."|cff00ff00"..p2_score)
   f[4]:SetPoint("TOP", f[3], "BOTTOM", 0, 0) 
   f[4]:Disable()
   f[4]:Show()
  end
   
  f[5]:SetText(L["wfound"])
  f[5]:SetPoint("TOP", p2_name ~= "" and f[4] or f[2], "BOTTOM", 0, btn_spacing * 2)
  f[5]:SetScript("OnEnter", function()
   GameTooltip:SetOwner(f[5],"ANCHOR_NONE")
   GameTooltip:ClearAllPoints()
   GameTooltip:SetPoint("LEFT", f[5], "RIGHT")
   GameTooltip:ClearLines()
   GameTooltip:AddDoubleLine("|cff00aaff"..string.upper(p1_name).."|r", "|cff00aaff"..string.upper(p2_name).."|r")
   local size1, size2, i = table.getn(p1_wf), table.getn(p2_wf)
   for i = 1,size1 > size2 and size1 or size2 do
    -- magic, do not touch
    GameTooltip:AddDoubleLine("|cffdddddd"..(p1_wf[i] and p1_wf[i] or "").."|r", "|cffdddddd"..(p2_wf[i] and p2_wf[i] or "").."|r")
   end
   GameTooltip:Show()
  end)
  f[5]:SetScript("OnLeave", function()
   GameTooltip:Hide()
  end)
  f[5]:Show()
  
  f[6]:SetText(L["backtomenu"])
  f[6]:SetPoint("TOP", f[5], "BOTTOM", 0, btn_spacing)
  f[6]:SetScript("OnClick", function()
   menustate = mn_main
   GenerateMenuButtons()
  end)
  f[6]:Show()
 elseif menustate == mn_gamereq then
  f[1]:SetText("|cff00ff88"..p2_name.."|r"..L["gamereq"])
  f[1]:SetPoint("TOP", Wowzzle_Menuframe.tex, "BOTTOM", 0, btn_spacing)
  f[1]:Disable()
  f[1]:Show()
  
  f[2]:SetText(L["accept"])
  f[2]:SetPoint("TOP", f[1], "BOTTOM", 0, btn_spacing)
  f[2]:SetScript("OnClick", function()
   SendAddonMessage(C["prefix"], C["verscheck"]..addonTable.version, "WHISPER", p2_name)
  end)
  f[2]:Show()
 
  f[3]:SetText(L["decline"])
  f[3]:SetPoint("TOP", f[2], "BOTTOM", 0, btn_spacing)
  f[3]:SetScript("OnClick", function()
   SendAddonMessage(C["prefix"], C["decline"], "WHISPER", p2_name)
   addonTable.Wowzzle_Dispose()
  end)
  f[3]:Show()
 elseif menustate == mn_connlost then
  f[1]:SetText(string.format(L["connlost"], addonTable.opponent.name))
  f[1]:SetPoint("TOP", Wowzzle_Menuframe.tex, "BOTTOM", 0, btn_spacing)
  f[1]:Disable()
  f[1]:Show()
  
  f[2]:SetText(L["backtomenu"])
  f[2]:SetPoint("TOP", f[1], "BOTTOM", 0, btn_spacing)
  f[2]:SetScript("OnClick", function()
   menustate = mn_main
   GenerateMenuButtons()
  end)
  f[2]:Show()
 else --if menustate == mn_main then
  -- main menu ( single player, multiplayer, credits, quit )
  f[1]:SetText(L["singleplayer"])
  f[1]:SetPoint("TOP", Wowzzle_Menuframe.tex, "BOTTOM", 0, -10) 
  f[1]:SetScript("OnClick", function()
   addonTable.InitGame()
  end)
  f[1]:Show()
  
  f[2]:SetText(L["multiplayer"])
  f[2]:SetPoint("TOP", f[1], "BOTTOM", 0, btn_spacing)
  f[2]:SetScript("OnClick", function()
   menustate = mn_multi1
   GenerateMenuButtons()
  end)
  f[2]:Show()
  
  f[3]:SetText(L["credits"])
  f[3]:SetPoint("TOP", f[2], "BOTTOM", 0, btn_spacing) 
  f[3]:SetScript("OnClick", function()
   menustate = mn_credits
   GenerateMenuButtons()
  end)
  f[3]:Show()
  
  f[4]:SetText(L["quit"])
  f[4]:SetPoint("TOP", f[3], "BOTTOM", 0, btn_spacing) 
  f[4]:SetScript("OnClick", function()
   addonTable.Wowzzle_Dispose()
  end)
  f[4]:Show()
  --
 end
end

addonTable.OpenGameRequestInterface = function(name)
 if not Wowzzle_Menuframe then
  addonTable.Mainmenu_Initialize()
 end
 p2_name = name
 menustate = mn_gamereq
 Wowzzle_Menuframe:ClearAllPoints()
 Wowzzle_Menuframe:SetPoint("LEFT")
 GenerateMenuButtons()
end

local function GenerateMainMenu()
 local f = addonTable.CreateDialogFrame(UIParent,true)
 f:SetWidth(200)
 f:SetHeight(300)
 f:SetClampedToScreen(true)
 f:SetPoint("CENTER")
 f.tex = f:CreateTexture()
 f.tex:SetPoint("TOP", f, "TOP")
 f.tex:SetWidth(150)
 f.tex:SetHeight(100)
 f.tex:SetTexture("interface\\addons\\wowzzle\\logo")
 f.buttons = {}
 local i
 for i = 1,6 do
  table.insert(f.buttons,addonTable.CreateSimpleButton(f))
 end
 if not Wowzzle__editbox then
  Wowzzle__editbox =  CreateFrame("editbox", "Wowzzle__editbox", f, "InputBoxTemplate")
 end
 local edt = Wowzzle__editbox
 edt:SetParent(f)
 edt:SetAutoFocus(false)
 edt:SetWidth(150)
 edt:SetHeight(30)
 edt:SetScript("OnEscapePressed", function(...) edt:ClearFocus() end)
 edt:Hide()
 
 menustate = mn_main
 Wowzzle_Menuframe = f
 GenerateMenuButtons()
end

addonTable.Mainmenu_Initialize = function(arg)
 if Wowzzle_Menuframe then 
  Wowzzle_Menuframe:Show()
 else
  addonTable:Timer_Init()
  GenerateMainMenu()
 end
 menustate = mn_main
 GenerateMenuButtons()
end

addonTable.ShowGameResults = function(arg, totalscore, wordsfound, opp)
 if not Wowzzle_Menuframe then
  addonTable.Mainmenu_Initialize()
 end
 
 if arg == "datareceived" then
  wipe(p2_wf)
  local w
  for w in string.gmatch(wordsfound, "(%w+)") do
   table.insert(p2_wf,w)
  end
  p2_score  = totalscore
  menustate = mn_results
  GenerateMenuButtons()
  return
 end

 if arg == "pingtimeout" then
  menustate = mn_connlost
  GenerateMenuButtons()
  return
 end
 
 p1_name  = UnitName("player")
 p1_score = totalscore
 p1_wf = {}
 for k, v in pairs(wordsfound) do
  p1_wf[k] = v
 end
 
 if arg == "multiplayer" then
  p2_name  = opp.name
  --p2_score = opp.score
  --p2_wf    = {"Retrieving data.."}
 else
  p2_name  = ""
  p2_score = ""
  p2_wf    = {}
 end
 
 menustate = mn_results
 GenerateMenuButtons()
end

addonTable.DisposeMenu = function()
 if Wowzzle_Menuframe then
   wipe(Wowzzle_Menuframe.buttons)
   if Wowzzle__editbox then
    Wowzzle__editbox:SetScript("OnEnterPressed",  nil)
   end
   Wowzzle_Menuframe:Hide()
   Wowzzle_Menuframe = nil
  end
end

-- slash command
SLASH_WOWZZLE1 = "/wowzzle"
SlashCmdList["WOWZZLE"] = addonTable.Mainmenu_Initialize